From 020ff1e5a6c4265ebe8bcb807e15e5576e98e92f Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 16 2020 17:24:50 +0000
Subject: [PATCH 1428/2232] Merge pull request #478 from dtolnay/enumint


Fix missing cstdint import when generating enums
---

diff --git a/syntax/mod.rs b/syntax/mod.rs
index 7f9b918..131639f 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -90,6 +90,7 @@ pub struct Enum {
     pub brace_token: Brace,
     pub variants: Vec<Variant>,
     pub repr: Atom,
+    pub repr_type: Type,
 }
 
 pub struct ExternFn {
diff --git a/syntax/parse.rs b/syntax/parse.rs
index c4549ea..5e10116 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -7,7 +7,7 @@ use crate::syntax::{
     Namespace, Pair, Receiver, Ref, ResolvableName, Signature, Slice, Struct, Ty1, Type, TypeAlias,
     Var, Variant,
 };
-use proc_macro2::{Delimiter, Group, TokenStream, TokenTree};
+use proc_macro2::{Delimiter, Group, Span, TokenStream, TokenTree};
 use quote::{format_ident, quote, quote_spanned};
 use syn::parse::{ParseStream, Parser};
 use syn::punctuated::Punctuated;
@@ -180,6 +180,9 @@ fn parse_enum(cx: &mut Errors, item: ItemEnum, namespace: &Namespace) -> Result<
         }
     }
 
+    let ident = Ident::new(repr.as_ref(), Span::call_site());
+    let repr_type = Type::Ident(ResolvableName::new(ident));
+
     Ok(Api::Enum(Enum {
         doc,
         enum_token,
@@ -187,6 +190,7 @@ fn parse_enum(cx: &mut Errors, item: ItemEnum, namespace: &Namespace) -> Result<
         brace_token,
         variants,
         repr,
+        repr_type,
     }))
 }
 
diff --git a/syntax/types.rs b/syntax/types.rs
index 90a8221..92c9a75 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -94,6 +94,7 @@ impl<'a> Types<'a> {
                     add_resolution(&strct.name);
                 }
                 Api::Enum(enm) => {
+                    all.insert(&enm.repr_type);
                     let ident = &enm.name.rust;
                     if !type_names.insert(ident)
                         && (!cxx.contains(ident)

